var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target, mod));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  activate: () => activate,
  deactivate: () => deactivate
});
module.exports = __toCommonJS(src_exports);
var vscode = __toESM(require("vscode"));

// src/util.ts
var import_compiler_sfc = require("@vue/compiler-sfc");

// src/KNode.ts
var KNode = class {
  constructor(tag, clazz, _tag) {
    this.tag = tag;
    this.originTag = _tag;
    this.clazz = clazz;
    this.children = [];
  }
  addKNode(kNode) {
    this.children.push(kNode);
  }
  getCSS(depth = 0, includeTag2 = false) {
    const flag = this.clazz || includeTag2 && this.tag;
    let inner = `${this.children.map((i) => i.getCSS(flag ? depth + 1 : depth, includeTag2)).join("\n")}`;
    if (!flag) {
      return inner;
    } else {
      if (inner) {
        inner = `
${inner}`;
      }
      const space = " ".repeat(2 * depth);
      const selector = `${space}${includeTag2 ? this.tag : ""}${this.clazz}`;
      return `${selector} {
${inner}
${space}}`;
    }
  }
  isSame(kNode) {
    if (this.tag !== kNode.tag)
      return false;
    if (this.clazz !== kNode.clazz)
      return false;
    if (this.children.length !== kNode.children.length)
      return false;
    for (let i = 0; i < this.children.length; i++) {
      if (!this.children[i].isSame(kNode.children[i]))
        return false;
    }
    return true;
  }
};

// src/util.ts
function parseSFCTemplateBlock(node) {
  const kNode = new KNode("", "", node.tag);
  walk(node, kNode);
  return kNode;
}
function isAttributeNode(node) {
  return !!node.value;
}
function walk(node, parentKNode, depth = 0) {
  var _a;
  if (node.type === 9) {
    node.branches.forEach((n) => walk(n, parentKNode, depth));
  } else if (node.type === 10 || node.type === 11) {
    node.children.forEach((n) => walk(n, parentKNode, depth));
  } else if (node.type === 1) {
    if (node.tag && (node.tagType === 0 || node.tagType === 1)) {
      const clazz = node.props.find((item) => item.name === "class");
      const tag = node.tagType === 0 ? node.tag : "";
      let clz = "";
      if (clazz && isAttributeNode(clazz)) {
        const content = (_a = clazz.value) == null ? void 0 : _a.content.trim();
        if (content)
          clz = `.${content.split(/\s/g).sort().join(".")}`;
      }
      const t = new KNode(tag === "template" ? "" : tag, clz, node.tag);
      parentKNode.addKNode(t);
      parentKNode = t;
    }
    if (node.children)
      node.children.forEach((n) => walk(n, parentKNode, depth + 1));
  } else {
  }
  let i = parentKNode.children.length - 1;
  while (i > 0) {
    const index = parentKNode.children.findIndex((item) => item.isSame(parentKNode.children[i]));
    if (index !== -1 && index !== i) {
      parentKNode.children.splice(i, 1);
    }
    i--;
  }
  const temp = parentKNode.children.reduce((prev, cur) => {
    const key = cur.tag + cur.clazz;
    if (prev[key])
      prev[key].children.push(...cur.children);
    else
      prev[key] = cur;
    return prev;
  }, {});
  parentKNode.children = [...Object.values(temp)];
}
function generateCSS(fileOption, {
  closingTag: closingTag2 = "</style>",
  openingTag: openingTag2 = '<style lang="scss" scoped>',
  includeTag: includeTag2 = false
} = {}) {
  const template = transformSourceToTemplate(fileOption);
  if (template) {
    let css = parseSFCTemplateBlock(template).getCSS(0, includeTag2);
    css = `${openingTag2}
${css}
${closingTag2}`;
    return css;
  }
}
function transformSourceToTemplate(fileOption) {
  var _a;
  const result = (0, import_compiler_sfc.compileTemplate)(__spreadProps(__spreadValues({}, fileOption), {
    compilerOptions: {
      hoistStatic: false
    }
  }));
  const template = (_a = result.ast) == null ? void 0 : _a.children.find((item) => item.tag === "template");
  return template;
}

// src/index.ts
var command = "vue-nested-css-generator.generate";
var openingTag = "vncg.openingTag";
var closingTag = "vncg.closingTag";
var includeTag = "vncg.includeTag";
function generateCSSFromActiveTextEditor() {
  const editor = vscode.window.activeTextEditor;
  if (!editor)
    return;
  const source = editor.document.getText();
  const config = vscode.workspace.getConfiguration();
  const option = {
    includeTag: config.get(includeTag),
    openingTag: config.get(openingTag),
    closingTag: config.get(closingTag)
  };
  const css = generateCSS({
    source,
    id: editor.document.fileName,
    filename: editor.document.fileName
  }, option);
  if (css) {
    vscode.window.showInformationMessage("Already put the generated css code to the clipboard");
    vscode.env.clipboard.writeText(css);
  }
}
function activate(ctx) {
  ctx.subscriptions.push(vscode.commands.registerCommand(command, () => {
    generateCSSFromActiveTextEditor();
  }));
}
function deactivate() {
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  activate,
  deactivate
});
